{$APPTYPE CONSOLE}
uses
  SysUtils, testlib;
var
  i, n, o, a, abal, obal, asbal, osbal: Integer;
  m: array of Integer;
begin
  n := inf.ReadInteger;
  SetLength(m, 2 * n);
  for i := 0 to High(m) do m[i] := inf.ReadInteger;
  i := 0; abal := 0; obal := 0; asbal := 0; osbal := 0;
  while not ans.SeekEof do begin
    o := ouf.ReadInteger;
    case o of
      1: begin Inc(obal); Inc(osbal, m[i]); end;
      2: begin Dec(obal); Dec(osbal, m[i]); end;
      else Quit(_PE, Format('%d not in [1, 2]', [o]));
    end;
    a := ans.ReadInteger;
    case a of
      1: begin Inc(abal); Inc(asbal, m[i]); end;
      2: begin Dec(abal); Dec(asbal, m[i]); end;
      else Quit(_FAIL, Format('%d not in [1, 2]', [a]));
    end;
    Inc(i);
  end;
  if not ouf.SeekEof then
    Quit(_PE, 'Extra characters in output');
  if abal <> 0 then Quit(_FAIL, 'Subgroups not equal');
  if obal <> 0 then Quit(_WA, 'Subgroups not equal');
  if Abs(osbal) > Abs(asbal) then Quit(_WA, Format('Not optimal: %d < %d', [asbal, osbal]));
  if Abs(osbal) < Abs(asbal) then Quit(_FAIL, Format('Answer not optimal: %d < %d', [osbal, asbal]));
  Quit(_OK, '');
end.
